package cn.ecpark.service.usergw.biz.filters.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import org.apache.dubbo.config.ReferenceConfig;
import org.apache.dubbo.rpc.service.GenericService;

import lombok.extern.slf4j.Slf4j;

/**
 * GenericServicePool
 */
@Slf4j
public class GenericServicePool {

    private class GenericServiceManager {

        Lock lock = new ReentrantLock();

        LinkedList<GenericService> idle = new LinkedList<>();
        LinkedList<GenericService> busy = new LinkedList<>();

        private String key;

        @Override
        public int hashCode() {
            return this.key.hashCode();
        }

        /**
         * @return String return the key
         */
        public String getKey() {
            return key;
        }

        /**
         * @param key the key to set
         */
        public void setKey(String key) {
            this.key = key;
        }

        public GenericService get() {
            try {
                if(lock.tryLock(15L, TimeUnit.SECONDS)) {
                    return idle.pop();
                } else {
                    log.error(this.key + ": 超时{}秒", 15);
                }
            } catch (Exception e) {
                //TODO: handle exception
            } finally {
                lock.unlock();
            }
            return null;
        }




        public GenericServiceManager() {
            idle = new LinkedList<>();
            busy = new LinkedList<>();
        }

    }


    HashMap<String, GenericServiceManager> gsDictionary;

    public GenericServicePool() {
        gsDictionary = new HashMap<String, GenericServiceManager>();
    }

 

    public GenericService get(String key) {

    }

    public GenericService add(String key, Object genericService) {

    }

}